
;Dialog Window With Combo Box - DednDave, 4-2012

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    DlgCombo.inc
        .LIST

;###############################################################################################

TtElapse EQU 2500   ;"Unacceptable Character" balloon tip elapse time in mS

;###############################################################################################

        .DATA

szTtClass db 'tooltips_class32',0
szTtTitle db 'Unacceptable Character',0
szTtText  db 'You can only type a number here.',0
szCurrent db 'Current Value: '
szValue   db 256 dup(?)
szNull    db 0

;------------------------------

        .DATA?

        ALIGN   4

hInstance   dd ?
hDlg        dd ?
hIcon       dd ?
hStatic     dd ?
hComboBox   dd ?
hComboEdit  dd ?
hTool       dd ?
lpfnCEdit   dd ?
dwTimerFlag dd ?

tti         TOOLINFO <>

;###############################################################################################

        .CODE

;***********************************************************************************************

DlgProc PROC    hWndDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     eax,uMsg
        cmp     eax,WM_MOVE
        jz      DlgPr2

        cmp     eax,WM_SIZE
        jz      DlgPr2

        cmp     eax,WM_KILLFOCUS
        jz      DlgPr2

        cmp     eax,WM_INITDIALOG
        jz      DlgPrX

        cmp     eax,WM_CLOSE
        jz      DlgPrY

;------------------------------

DlgPr0: xor     eax,eax

DlgPr1: ret

;------------------------------

;WM_MOVE
;WM_SIZE
;WM_KILLFOCUS

DlgPr2: call    StopBalloon

;------------------------------

DlgPr3: mov     eax,TRUE
        jmp     DlgPr1

;------------------------------

;WM_INITDIALOG

DlgPrX: push    ebx

;intialize the global dialog window handle

        mov     ebx,hWndDlg
        mov     hDlg,ebx

;load the icon from resource and set to caption bar

        INVOKE  LoadIcon,hInstance,IDI_ICON
        mov     hIcon,eax
        INVOKE  SendMessage,ebx,WM_SETICON,ICON_BIG,eax

;get and save the handle for the static text and combo box controls

        INVOKE  GetDlgItem,ebx,IDC_STATIC
        mov     hStatic,eax
        INVOKE  GetDlgItem,ebx,IDC_COMBO
        mov     hComboBox,eax

;get and save the handle for the combo box edit control

        call    GetCEHandle
        mov     hComboEdit,ebx

;get and save the original WndProc for the edit control

        INVOKE  GetWindowLong,ebx,GWL_WNDPROC
        mov     lpfnCEdit,eax

;subclass the edit control

        INVOKE  SetWindowLong,ebx,GWL_WNDPROC,CEditProc

;create the "Unacceptable Character" balloon tip

        INVOKE  MakeTt,IDW_TOOL,offset tti
        mov     hTool,eax
        pop     ebx
        jmp     DlgPr3

;------------------------------

;WM_CLOSE

DlgPrY: INVOKE  SetWindowLong,hComboEdit,GWL_WNDPROC,lpfnCEdit
        INVOKE  EndDialog,hWndDlg,NULL
        jmp     DlgPr3

;------------------------------

DlgProc ENDP

;***********************************************************************************************

CEditProc PROC  hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     eax,uMsg
        cmp     eax,WM_CHAR
        jz      CEdPr2

        cmp     eax,WM_GETDLGCODE
        jz      CEdPr5

        cmp     eax,WM_KILLFOCUS
        jz      CEdPr4

        cmp     eax,WM_PASTE
        jz      CEdPrB

        cmp     eax,WM_TIMER
        jz      CEdPrH

;------------------------------

;return via original WndProc

CEdPr0: INVOKE  CallWindowProc,lpfnCEdit,hWnd,uMsg,wParam,lParam

;------------------------------

;return EAX

CEdPr1: ret

;------------------------------

;WM_CHAR

;for characters we want to allow, we exit by calling the original WndProc
;for characters we do no want to allow, we return EAX=0, meaning the WM_CHAR message has been handled

CEdPr2: mov     edx,wParam
        call    CharFilter
        jnc     CEdPr0

;------------------------------

;return FALSE

CEdPr3: xor     eax,eax
        jmp     CEdPr1

;------------------------------

;WM_KILLFOCUS

CEdPr4: call    StopBalloon
        jmp short CEdPr6

;------------------------------

;WM_GETDLGCODE

CEdPr5: cmp     wParam,VK_RETURN
        mov     edx,lParam
        jnz     CEdPr0

        cmp     [edx].MSG.message,WM_KEYDOWN
        jnz     CEdPr0

;enter key was pressed or keyboard focus was lost

CEdPr6: push    ebx
        xor     ebx,ebx
        INVOKE  SendMessage,hWnd,EM_GETMODIFY,ebx,ebx
        or      eax,eax
        jz      CEdPrA

        push    esi
        mov     esi,offset szValue
        mov     [esi],bl
        INVOKE  GetWindowText,hWnd,esi,sizeof szValue
        cmp     bl,[esi]                             ;if it's a null string, we ignore it
        jz      CEdPr9

;see if the string is already in the drop-down list
;if it is at the top of the list, do nothing
;if it is elsewhere in the list, delete the old one and re-insert it at the top
;if it is not in the list, we just insert it at the top

        push    edi
        mov     edi,hComboBox
        INVOKE  SendMessage,edi,CB_FINDSTRINGEXACT,-1,esi
        inc     eax
        jz      CEdPr7

        dec     eax
        jz      CEdPr8

        INVOKE  SendMessage,edi,CB_DELETESTRING,eax,ebx

CEdPr7: INVOKE  SendMessage,edi,CB_INSERTSTRING,ebx,esi

;update the static text
;this is for demo purposes

CEdPr8: INVOKE  SetWindowText,hStatic,offset szCurrent

;the combo box does not redraw properly after setting static text (???)
;we force it to redraw correctly with SetWindoPos

Swp_Flags = SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW or SWP_FRAMECHANGED

        INVOKE  SetWindowPos,edi,ebx,ebx,ebx,ebx,ebx,Swp_Flags
        pop     edi

;clear the edit control modify flag

CEdPr9: INVOKE  PostMessage,hWnd,EM_SETMODIFY,ebx,ebx
        pop     esi

CEdPrA: pop     ebx
        jmp     CEdPr0

;------------------------------

;WM_PASTE

;1) OpenClipboard fails
;   a) return FALSE, ignoring WM_PASTE message
;
;2) no CF_TEXT data or GetClipboardData fails or GlobalLock fails
;   a) CloseClipboard
;   b) return FALSE, ignoring WM_PASTE message
;
;3) text contains non-numeric characters
;   a) GlobalUnlock
;   b) CloseClipboard
;   c) activate balloon tip and start timer
;   d) return FALSE, ignoring WM_PASTE message
;
;4) text contains all numeric characters
;   a) GlobalUnlock
;   b) CloseClipboard
;   c) return via call to original WndProc, which performs the paste

CEdPrB: INVOKE  OpenClipboard,NULL
        or      eax,eax
        jz      CEdPr1

        push    ebx
        xor     ebx,ebx
        INVOKE  GetClipboardData,CF_TEXT
        or      eax,eax
        jz      CEdPrF

        push    eax
        INVOKE  GlobalLock,eax
        or      eax,eax
        pop     ecx
        jz      CEdPrE

        xor     edx,edx
        inc     ebx
        jmp short CEdPrD

CEdPrC: call    CharFilter
        inc     eax
        jc      CEdPrE

CEdPrD: mov     dl,[eax]
        or      dl,dl
        jnz     CEdPrC

        inc     ebx

CEdPrE: INVOKE  GlobalUnlock,ecx

CEdPrF: INVOKE  CloseClipboard
        or      ebx,ebx
        jz      CEdPrG

        dec     ebx
        jnz     CEdPr0

        mov     ebx,hTool
        mov     dwTimerFlag,ebx
        INVOKE  GetTtPos,hComboEdit
        INVOKE  SendMessage,ebx,TTM_TRACKPOSITION,0,eax
        INVOKE  PostMessage,ebx,TTM_TRACKACTIVATE,TRUE,offset tti
        INVOKE  SetTimer,hWnd,IDT_TIMER,TtElapse,NULL

CEdPrG: pop     ebx
        jmp     CEdPr3

;------------------------------

;WM_TIMER

CEdPrH: call    StopBalloon
        jmp     CEdPr3

;------------------------------

CEditProc ENDP

;***********************************************************************************************

CharFilter PROC

;We return with CF cleared for characters we want to allow
;and CF set for characters we do not want to allow.
;This routine is used for both keyboard entry and testing pasted strings.

        cmp     edx,30h
        jb      CharF1

        cmp     edx,39h
        ja      CharF2

CharF0: clc

CharF1: ret

CharF2: stc
        ret

CharFilter ENDP

;***********************************************************************************************

GetTtPos PROC   hEdit:HANDLE

;locate the balloon tooltip

        LOCAL   rcEdit:RECT

        INVOKE  GetWindowRect,hEdit,addr rcEdit
        mov     eax,rcEdit.top-2
        add     eax,60000h
        mov     ax,word ptr rcEdit.left
        ret

GetTtPos ENDP

;***********************************************************************************************

StopBalloon PROC

;hide the balloon tooltip if it is showing

        cmp     dwTimerFlag,0
        jz      StopB0

        INVOKE  KillTimer,hComboEdit,IDT_TIMER
        xor     eax,eax
        mov     dwTimerFlag,eax
        INVOKE  SendMessage,hTool,TTM_TRACKACTIVATE,eax,offset tti

StopB0: ret

StopBalloon ENDP

;***********************************************************************************************

GetCEHandle PROC

;get combo box edit control handle

;Call With: EAX = handle of the combo box
;
;  Returns: EBX = handle of the combo box edit control
;
;Also Uses: EAX, ECX, EDX
;
;------------------------------

        LOCAL   cbi:COMBOBOXINFO

;COMBOBOXINFO STRUCT
;  cbSize       dd ?
;  rcItem       RECT <>
;  rcButton     RECT <>
;  stateButton  dd ?
;  hwndCombo    dd ?
;  hwndItem     dd ?
;  hwndList     dd ?

        lea     ebx,cbi
        mov     [ebx].COMBOBOXINFO.cbSize,sizeof COMBOBOXINFO
        INVOKE  GetComboBoxInfo,eax,ebx
        mov     ebx,[ebx].COMBOBOXINFO.hwndItem
        ret

GetCEHandle ENDP

;***********************************************************************************************

MakeTt  PROC    nToolId:UINT,lpToolInfoStruct:LPVOID

;create a balloon tooltip

;  Returns: EAX = hTool

;TOOLINFO STRUCT
;  cbSize   dd ?
;  uFlags   dd ?
;  hWnd     dd ?
;  uId      dd ?
;  rect     RECT <>
;    left     dd ?
;    top      dd ?
;    right    dd ?
;    bottom   dd ?
;  hInst    dd ?
;  lpszText dd ?
;  lParam   dd ?

        xor     ecx,ecx
        mov     edx,CW_USEDEFAULT
        INVOKE  CreateWindowEx,WS_EX_TOOLWINDOW,offset szTtClass,ecx,WS_POPUP or TTS_BALLOON,
                edx,edx,edx,edx,ecx,ecx,hInstance,ecx
        mov     edx,lpToolInfoStruct
        xor     ecx,ecx
        mov     [edx].TOOLINFO.cbSize,sizeof TOOLINFO
        mov     [edx].TOOLINFO.uFlags,TTF_TRACK or TTF_ABSOLUTE
        mov     [edx].TOOLINFO.hWnd,ecx                          ;HWND_DESKTOP = 0
        push    nToolId
        pop     [edx].TOOLINFO.uId
        mov     [edx].TOOLINFO.rect.left,ecx
        mov     [edx].TOOLINFO.rect.top,ecx
        mov     [edx].TOOLINFO.rect.right,32767
        mov     [edx].TOOLINFO.rect.bottom,32767
        push    hInstance
        pop     [edx].TOOLINFO.hInst
        mov     [edx].TOOLINFO.lpszText,offset szTtText
        mov     [edx].TOOLINFO.lParam,ecx
        push    eax
        INVOKE  SendMessage,eax,TTM_ADDTOOL,ecx,edx
        pop     eax
        push    eax
        INVOKE  SendMessage,eax,TTM_SETTITLE,TTI_ERROR,offset szTtTitle
        pop     eax
        ret

MakeTt  ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        pop     ecx
        pop     edx

;------------------------------

;create dialog box

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        INVOKE  DialogBoxParam,eax,IDW_DLG,edi,DlgProc,edi

;------------------------------

;exit program

        INVOKE  ExitProcess,eax

;------------------------------

_main   ENDP

;###############################################################################################

        END     _main

